"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Service = void 0;
const oauth_connector_1 = require("@fusebit-int/oauth-connector");
const superagent_1 = __importDefault(require("superagent"));
class Service extends oauth_connector_1.OAuthConnector.Service {
    getEventsFromPayload(ctx) {
        return [{ data: ctx.req.body, type: ctx.req.body.event_name }];
    }
    getAuthIdFromEvent(ctx, event) {
        return event.data.user_id;
    }
    async validateWebhookEvent(ctx) {
        const webhookSecret = ctx.req.headers['x-gitlab-token'];
        return webhookSecret === ctx.state.manager.config.configuration.webhookSecret;
    }
    async initializationChallenge(ctx) {
        return false;
    }
    async getTokenAuthId(ctx, token) {
        const data = await superagent_1.default
            .get('https://gitlab.com/api/v4/user/')
            .set('Authorization', `Bearer ${token.access_token}`);
        return data.body.id;
    }
    getWebhookEventType(event) {
        return event.type;
    }
}
exports.Service = Service;
//# sourceMappingURL=Service.js.map